diff --git a/services/java/com/android/server/IntentResolver.java b/services/java/com/android/server/IntentResolver.java
index b3d7220..a9bcaff 100644
--- a/services/java/com/android/server/IntentResolver.java
+++ b/services/java/com/android/server/IntentResolver.java
@@ -37,7 +37,12 @@ import android.util.Printer;
 
 import android.content.Intent;
 import android.content.IntentFilter;
-
+import android.content.pm.ResolveInfo;
+import java.util.ListIterator;
+import android.os.IAquiferService;
+import android.os.AquiferList;
+import android.os.Binder;
+import android.os.ServiceManager;
 /**
  * {@hide}
  */
@@ -306,12 +311,97 @@ public abstract class IntentResolver<F extends IntentFilter, R extends Object> {
         }
         sortResults(finalList);
 
-        if (debug) {
+	//Adwait's patch begins
+	if(this.toString().contains("ActivityIntentResolver"))
+	{
+		//Supply the calling process's procname, pid and packagename and the action with the intent
+		//then in th aquiferservice get the label, then the effective policy, and check if the action has any Principals.
+		//return the filter:PrincipalList from the AquiferService. The finalList contains only those apps that are also in 
+		//the PrincipalList.
+		//Getting the sender's processname, pid, packagename
+//		String sprocessName=intent.getStringExtra("processName");
+//		int spid=intent.getIntExtra("pid",0);
+		String sprocessName=intent.getProcessName();
+		int spid=intent.getPid();
+		//Getting the Intent Action
+		String action = intent.getAction();
+		//System.out.println("Filtering results for "+sprocessName+":"+spid+":"+action);
+		
+		IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        	try{   
+			if(finalList==null){
+				//System.out.println("null finalList");
+			}
+			else
+			{	/*
+				ListIterator li2 = finalList.listIterator();
+				System.out.println("Initial List Contents:");
+				if(li2!=null)
+				{
+					while(li2.hasNext())
+					{
+						ResolveInfo rinfo =(ResolveInfo) li2.next();
+						if(rinfo!=null && rinfo.activityInfo!=null && rinfo.activityInfo.name!=null)
+							System.out.println(rinfo.activityInfo.name);
+						else	
+							System.out.println("Something is null, probably rinfo.activityInfo:"+rinfo.activityInfo);
+					}	
+				}*/
+				if(sprocessName!=null && !sprocessName.startsWith("com.android") && !sprocessName.equals("system"))	
+				{
+					AquiferList PrincipalList = aquifer.getPrincipalList(sprocessName, spid, action);
+					if(PrincipalList!=null)
+					{	
+						if(PrincipalList.isEmpty())
+						{
+							//System.out.println("null principallist returned for action "+action);		
+							return finalList;
+						}
+						//System.out.println("Non null principallist returned for action "+action);
+						ListIterator li = finalList.listIterator();
+						int i=0;
+						while(li.hasNext())
+                				{
+                        				//Filtering the final list displayed to the user
+                        				ResolveInfo rinfo =(ResolveInfo) li.next();
+	                        			String rpackageName = rinfo.activityInfo.packageName;
+							if(PrincipalList.contains(rpackageName))
+							{
+								//System.out.println("The component "+rinfo.activityInfo.name+" passes all the checks");
+							}
+							else
+							{
+        	                                        	//start from the beginning
+								//System.out.println("Removing component "+rinfo.activityInfo.name);
+								finalList.remove(rinfo);
+                	                	                li = finalList.listIterator();
+                        	                       		// i=0; 
+							}
+							i++;
+						}
+					}
+					else
+					{
+						//System.out.println("No principals for the current action "+action);
+					}
+				}
+			}
+        	}
+        	catch(Exception e)
+        	{	
+			System.out.println("Exception at activity intent resolver:"+e);	
+		}
+	}
+
+	//Adwait's check ends
+       
+	 if (debug) {
             Slog.v(TAG, "Final result list:");
             for (R r : finalList) {
                 Slog.v(TAG, "  " + r);
             }
         }
+	//System.out.println("Generated the final list");
         return finalList;
     }
 
diff --git a/services/java/com/android/server/SystemServer.java b/services/java/com/android/server/SystemServer.java
index 3ae62ad..af10091 100644
--- a/services/java/com/android/server/SystemServer.java
+++ b/services/java/com/android/server/SystemServer.java
@@ -62,6 +62,7 @@ import java.io.File;
 import java.util.Timer;
 import java.util.TimerTask;
 
+
 class ServerThread extends Thread {
     private static final String TAG = "SystemServer";
     private static final String ENCRYPTING_STATE = "trigger_restart_min_framework";
@@ -132,16 +133,26 @@ class ServerThread extends Thread {
         NetworkTimeUpdateService networkTimeUpdater = null;
 
         // Critical services...
-        try {
+        
+	try {
+
             Slog.i(TAG, "Entropy Service");
             ServiceManager.addService("entropy", new EntropyService());
-
+	
             Slog.i(TAG, "Power Manager");
             power = new PowerManagerService();
             ServiceManager.addService(Context.POWER_SERVICE, power);
 
             Slog.i(TAG, "Activity Manager");
             context = ActivityManagerService.main(factoryTest);
+	
+	    //Adwait : Registering the AquiferService
+            try {
+                Slog.i(TAG, "Aquifer Service");
+                ServiceManager.addService("Aquifer",new AquiferService(context));
+            } catch (Throwable e) {
+                Slog.e(TAG, "Failure starting AquiferService", e);
+            }		
 
             Slog.i(TAG, "Telephony Registry");
             ServiceManager.addService("telephony.registry", new TelephonyRegistry(context));
@@ -170,9 +181,9 @@ class ServerThread extends Thread {
             }
 
             ActivityManagerService.setSystemProcess();
-
+	
             mContentResolver = context.getContentResolver();
-
+		
             // The AccountManager must come before the ContentService
             try {
                 Slog.i(TAG, "Account Manager");
diff --git a/services/java/com/android/server/am/ActivityManagerService.java b/services/java/com/android/server/am/ActivityManagerService.java
index df58e83..915a13a 100644
--- a/services/java/com/android/server/am/ActivityManagerService.java
+++ b/services/java/com/android/server/am/ActivityManagerService.java
@@ -15,7 +15,7 @@
  */
 
 package com.android.server.am;
-
+import android.os.IAquiferService;
 import com.android.internal.R;
 import com.android.internal.os.BatteryStatsImpl;
 import com.android.internal.os.ProcessStats;
@@ -1891,6 +1891,18 @@ public final class ActivityManagerService extends ActivityManagerNative
         }
 
         startProcessLocked(app, hostingType, hostingNameStr);
+	//Adwait's hook - startProcessLocked
+        /*if(info.packageName.equals("com.demoapps.adwait"))
+        {
+                IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+                try{
+			aquifer.hi(5);
+                    	System.out.println("Aquifer Says Hi!: "+processName);
+        	}
+                catch(Exception e)
+                {}
+        }*/
+
         return (app.pid != 0) ? app : null;
     }
 
@@ -1959,13 +1971,24 @@ public final class ActivityManagerService extends ActivityManagerNative
             if ("1".equals(SystemProperties.get("debug.assert"))) {
                 debugFlags |= Zygote.DEBUG_ENABLE_ASSERT;
             }
-
+		
+	    //Adwait's process creation hook
             // Start the process.  It will either succeed and return a result containing
             // the PID of the new process, or else throw a RuntimeException.
             Process.ProcessStartResult startResult = Process.start("android.app.ActivityThread",
                     app.processName, uid, uid, gids, debugFlags,
                     app.info.targetSdkVersion, null);
-
+	    /*if( app.processName!=null && !app.processName.equals("system") && !app.processName.startsWith("com.android."))
+	    {	
+		System.out.println("Setting internet for the process "+app.processName);
+	    	//Call AquiferService Here
+	   	IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+	    	try{
+	    		aquifer.setInternetPolicy(startResult.pid, uid, app.processName);
+	    	}
+	    	catch(Exception e)
+	    	{}
+	    }*/
             BatteryStatsImpl bs = app.batteryStats.getBatteryStats();
             synchronized (bs) {
                 if (bs.isOnBattery()) {
@@ -2229,6 +2252,17 @@ public final class ActivityManagerService extends ActivityManagerNative
             int grantedMode, IBinder resultTo,
             String resultWho, int requestCode, boolean onlyIfNeeded, boolean debug,
             String profileFile, ParcelFileDescriptor profileFd, boolean autoStopProfiler) {
+		//Adwait's code - Intent path	
+		/*
+		String processName=intent.getStringExtra("processName");
+		System.out.println("Inside act manager service");
+	        if(processName!=null && processName.contains(".AppAactivity"))
+         	{
+			if(intent.getPolicy()==null)
+				System.out.println("Null policy at ActivityManagerService");   
+			else System.out.println("Policy Exists at ActivityManagerService");
+		}*/
+		//ends
         return mMainStack.startActivityMayWait(caller, -1, intent, resolvedType,
                 grantedUriPermissions, grantedMode, resultTo, resultWho,
                 requestCode, onlyIfNeeded, debug, profileFile, profileFd, autoStopProfiler,
@@ -4089,6 +4123,26 @@ public final class ActivityManagerService extends ActivityManagerNative
     }
 
     public final void activityDestroyed(IBinder token) {
+	//Adwait's coded for destroying an activity
+	/*
+        IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+	int pid=-50;
+	String processName="boo";
+        try{    ActivityRecord r = ActivityRecord.forToken(token);
+		if(r==null)
+			System.out.println("Null Activity Record");
+                if(r.app==null)
+			System.out.println("Null app");
+		pid = r.app.pid;
+                processName = r.processName;
+                aquifer.destroyActivity(pid,processName);
+        }
+        catch(Exception e)
+        {
+                System.out.println("Exception at ActivityManagerService:activityDestroyed:"+e);
+        }*/
+        //Adwait's code ends
+
         if (DEBUG_SWITCH) Slog.v(TAG, "ACTIVITY DESTROYED: " + token);
         mMainStack.activityDestroyed(token);
     }
@@ -10480,6 +10534,44 @@ public final class ActivityManagerService extends ActivityManagerNative
 
                 ComponentName name = new ComponentName(
                         sInfo.applicationInfo.packageName, sInfo.name);
+		//Adwait's hook for attaching policy to services
+		//First getting the aggregate policy
+		/*
+		try
+		{IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+		AquiferPolicy aggPolicy=null;
+		String sprocessName = service.getStringExtra("processName");
+		String rprocessName = sInfo.processName;
+		System.out.println("Sender for the intent="+sprocessName);
+                System.out.println("Service selected = "+sInfo.name);        
+		if(rprocessName!=null && !sprocessName.contains("com.android") && !sprocessName.equals("system"))
+                {	
+			//System.out.println("Policy on the intent :");
+                        //System.out.println("IntentResolver::The processName is "+sprocessName);
+                        //Getting the aggregate policy (sending process+intent)
+                        aggPolicy = aquifer.aggregatePolicy(sprocessName,service);
+                        System.out.println("Aggregate Policy:");
+                        if(aggPolicy==null)
+                               	System.out.println("Aggregate Policy is null");
+                        else
+                                aggPolicy.displayAquiferPolicy();
+			if(aquifer.isAlive(rprocessName))
+			{	System.out.println("Process "+rprocessName+" is alive.");
+                                AquiferPolicy finalPolicy=aquifer.policyConvergence(rprocessName, aggPolicy);
+				aquifer.addComponentPolicy(rprocessName, finalPolicy);
+                                System.out.println("Policy:");
+                                finalPolicy.displayAquiferPolicy();
+			}
+			else
+			{
+				aquifer.addComponentPolicy(rprocessName, aggPolicy);
+			}
+		}}
+		catch(Exception e)
+		{
+			System.out.println("Exception at retrieveServiceLocked: adding policy to a service process:"+e);
+		}*/
+           	//ends 
                 r = mServices.get(name);
                 if (r == null) {
                     filter = new Intent.FilterComparison(service.cloneFilter());
diff --git a/services/java/com/android/server/am/ActivityStack.java b/services/java/com/android/server/am/ActivityStack.java
index 6c11953..5221a69 100644
--- a/services/java/com/android/server/am/ActivityStack.java
+++ b/services/java/com/android/server/am/ActivityStack.java
@@ -70,7 +70,9 @@ import java.lang.ref.WeakReference;
 import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
-
+import java.util.ListIterator;
+import android.os.IAquiferService;
+import android.os.ServiceManager;
 /**
  * State and management of a single stack of activities.
  */
@@ -694,23 +696,147 @@ final class ActivityStack {
         } else if (mInitialStartTime == 0) {
             mInitialStartTime = SystemClock.uptimeMillis();
         }
-        
+       	boolean x=false;
+		
+	//Adwait's code
+	String rcomponentName = "";
+	rcomponentName = r.realActivity.getClassName();
+	String action="";
+	if(r.intent.getAction()!=null)
+		action=r.intent.getAction();
+
+        //Getting Sender Information
+	String sprocessName="";
+	int spid=0;
+	try{
+//		sprocessName=r.intent.getStringExtra("processName");
+//        	spid=r.intent.getIntExtra("pid",0);
+		sprocessName=r.intent.getProcessName();
+        	spid=r.intent.getPid();
+	}
+        catch(Exception e)
+	{
+		System.out.println("Exception at startSpecificActivityLocked while getting the processName. pid="+spid+"::"+e);
+	}	
+	int resultcode=r.requestCode;
+	//System.out.println("startSpecificActivityLocked:The caller is "+sprocessName+":"+spid);
+	boolean callItself=false;
+	if(app!=null)
+	{
+		//System.out.println("startSpecificActivityLocked:The receiver has processrecord :"+app.pid);
+		if(app.pid==spid)
+		{
+			//System.out.println(sprocessName + ":" + spid + " calls itself");
+			callItself=true;
+		}		
+	}
+	//start the ringtone activity in a new process, i.e. remove the RINGTONE_PICKER case somehow. 
+	//Then before this condition, check if the activity being currently called is already in the workflow of the receiver. If so,
+	//Then simply restart it.
+        //if (app != null && app.thread != null && (app.processName.equals("system") || app.processName.equals("com.android.launcher") || app.processName.contains("chooser") || (r.intent.getAction()!=null && r.intent.getAction().equals(Intent.ACTION_CHOOSER)) || (r.intent.getAction()!=null && r.intent.getAction().equals("android.intent.action.RINGTONE_PICKER")) || callItself)) {
+	IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
         if (app != null && app.thread != null) {
-            try {
-                app.addPackage(r.info.packageName);
-                realStartActivityLocked(r, app, andResume, checkConfig);
-                return;
-            } catch (RemoteException e) {
-                Slog.w(TAG, "Exception when starting activity "
-                        + r.intent.getComponent().flattenToShortString(), e);
-            }
-
+	//	System.out.println("Process "+app.processName+" already exists:");
+		//Adwait's code for checking if the processname is the same process starting it
+		if(app.processName.equals("system") || app.processName.equals("com.android.launcher") || app.processName.contains("chooser") || (r.intent.getAction()!=null && r.intent.getAction().equals(Intent.ACTION_CHOOSER)) || (r.intent.getAction()!=null && r.intent.getAction().equals("android.intent.action.RINGTONE_PICKER")))
+		{}
+		else
+		{	
+			//In case sprocessName is null, i.e. the original process firing this intent is system or launcher
+			if(sprocessName==null)
+				sprocessName="";
+			//For a process holding multiple activities
+			boolean current=false;
+                        try{
+				//System.out.println("Checking if the process belongs to the same workflow");
+				//Check if the process of the activity is a part of the current workflow
+                                if(aquifer.isThisWorkflow(sprocessName, spid, app.processName, app.pid))
+					current=true;
+                        }
+                        catch(Exception e)
+                        {
+                                System.out.println("Exception while checking if process is in the current workflow:"+e);
+                        }
+			if(current)
+			{		
+				//System.out.println("Adding component to existing workflow");
+				String rpackageName = app.info.packageName;
+				int ruid = app.info.uid;
+                		try{
+                        		aquifer.addComponent(app.processName, app.pid, rpackageName, ruid, resultcode,rcomponentName);
+                		}
+                		catch(Exception e)
+                		{
+                        		System.out.println("Exception while adding component to the current workflow process "+app.processName+" :"+e);
+                		}
+			}
+			else
+			{	//current = false, i.e., 
+				//The app.processName is either a part of no workflow(HOW?) or a part of some other workflow.
+				//In either case, first try to destroy this particular participating component from its process.
+				//System.out.println("Killing and adding process to the workflow of "+sprocessName+":"+spid);
+				try{
+					aquifer.destroyEntireProcess(app.processName, app.pid);
+					//creating a new process
+					ProcessRecord rec = mService.startProcessLocked(r.processName, r.info.applicationInfo, true, 0,"activity", r.intent.getComponent(), false);
+        				//Getting Receiver information
+        				String rpackageName=rec.info.packageName;
+        				String rprocessName=rec.processName;
+        				int rpid=rec.pid;
+        				int ruid=rec.info.uid;
+					//System.out.println("New process "+rprocessName+":"+rpid+" created after killing it.");
+					if(rprocessName.equals("system") || rprocessName.equals("com.android.launcher") || rprocessName.contains("chooser") || (r.intent.getAction()!=null && r.intent.getAction().equals(Intent.ACTION_CHOOSER)) || (r.intent.getAction()!=null && r.intent.getAction().equals("android.intent.action.RINGTONE_PICKER")))
+					{}
+					else
+					{
+						aquifer.addParticipant( sprocessName, spid, rprocessName, rpid, rpackageName, ruid, resultcode, rcomponentName);
+					}
+				}
+				catch(Exception e)
+				{	System.out.println("Exception: call to destroyEntireProcess and addParticipant:"+e);
+				}	
+				return;//since the app.addPackage and realStartActivityLocked  part is useless for when we create a new process.
+			}
+			//System.out.println("Resuming process for activity");
+		}
+       		try {
+              		app.addPackage(r.info.packageName);
+                	realStartActivityLocked(r, app, andResume, checkConfig);
+                	return;
+            	} 
+		catch (RemoteException e) {
+                	Slog.w(TAG, "Exception when starting activity "+ r.intent.getComponent().flattenToShortString(), e);
+        	}    	
             // If a dead object exception was thrown -- fall through to
             // restart the application.
-        }
-
-        mService.startProcessLocked(r.processName, r.info.applicationInfo, true, 0,
+        	
+	}
+	//System.out.println("Starting a new process for the activity");
+	//Adwait's code: Adding a new participant
+	ProcessRecord rec = mService.startProcessLocked(r.processName, r.info.applicationInfo, true, 0,
                 "activity", r.intent.getComponent(), false);
+	//Getting Receiver information
+	
+	String rpackageName=rec.info.packageName;
+        String rprocessName=rec.processName;
+        int rpid=rec.pid;
+	int ruid=rec.info.uid;
+	
+	if(rprocessName.equals("system") || rprocessName.equals("com.android.launcher") || rprocessName.contains("chooser") || (r.intent.getAction()!=null && r.intent.getAction().equals(Intent.ACTION_CHOOSER)) || (r.intent.getAction()!=null && r.intent.getAction().equals("android.intent.action.RINGTONE_PICKER")))
+        {}
+	else{
+		//the actual call to addParticipant(..)
+		//System.out.println("Process "+rprocessName+":"+rpid+":"+rpackageName+" started by "+ sprocessName+":"+spid+"with resultcode"+resultcode);
+		try
+		{	
+			aquifer.addParticipant( sprocessName, spid, rprocessName, rpid, rpackageName, ruid, resultcode, rcomponentName); 
+		}
+		catch(Exception e)
+		{	
+			System.out.println("Exception while adding participant: ActivityStack:startSpecificActivityLocked");
+		}	
+		//Adwait's code ends
+	}
     }
     
     void stopIfSleepingLocked() {
@@ -2228,7 +2354,6 @@ final class ActivityStack {
             boolean componentSpecified, ActivityRecord[] outActivity) {
 
         int err = START_SUCCESS;
-
         ProcessRecord callerApp = null;
         if (caller != null) {
             callerApp = mService.getRecordForAppLocked(caller);
@@ -2244,6 +2369,7 @@ final class ActivityStack {
         }
 
         if (err == START_SUCCESS) {
+	    
             Slog.i(TAG, "START {" + intent.toShortString(true, true, true) + "} from pid "
                     + (callerApp != null ? callerApp.pid : callingPid));
         }
@@ -2831,7 +2957,19 @@ final class ActivityStack {
 
         // Don't modify the client's object!
         intent = new Intent(intent);
-
+	/*
+	//Adwait's code
+	try{
+		String sprocessName=intent.getStringExtra("processName");
+        	int spid=intent.getIntExtra("pid",0);
+        	System.out.println("The caller at ActivityStack is "+sprocessName+":"+spid);
+	}
+	catch(Exception e)
+	{
+		System.out.println("Exception at ActivityStack:startActivityMayWait while getting extras:"+e);
+	}
+	//Adwait's code ends
+	*/
         // Collect information about the target of the Intent.
         ActivityInfo aInfo = resolveActivity(intent, resolvedType, debug,
                 profileFile, profileFd, autoStopProfiler);
@@ -2859,6 +2997,7 @@ final class ActivityStack {
                 // This may be a heavy-weight process!  Check to see if we already
                 // have another, different heavy-weight process running.
                 if (aInfo.processName.equals(aInfo.applicationInfo.packageName)) {
+		    
                     if (mService.mHeavyWeightProcess != null &&
                             (mService.mHeavyWeightProcess.info.uid != aInfo.applicationInfo.uid ||
                             !mService.mHeavyWeightProcess.processName.equals(aInfo.processName))) {
@@ -2921,7 +3060,8 @@ final class ActivityStack {
                     }
                 }
             }
-            
+	  //Adwait: Adding policy to the sender process  
+	    
             int res = startActivityLocked(caller, intent, resolvedType,
                     grantedUriPermissions, grantedMode, aInfo,
                     resultTo, resultWho, requestCode, callingPid, callingUid,
@@ -3543,7 +3683,6 @@ final class ActivityStack {
         if (mService.mFocusedActivity == r) {
             mService.mFocusedActivity = null;
         }
-
         r.configDestroy = false;
         r.frozenBeforeDestroy = false;
 
diff --git a/services/java/com/android/server/pm/PackageManagerService.java b/services/java/com/android/server/pm/PackageManagerService.java
index 6b61c47..a66a6a0 100644
--- a/services/java/com/android/server/pm/PackageManagerService.java
+++ b/services/java/com/android/server/pm/PackageManagerService.java
@@ -83,6 +83,7 @@ import android.os.FileUtils;
 import android.os.Handler;
 import android.os.HandlerThread;
 import android.os.IBinder;
+import android.os.IAquiferService;
 import android.os.Looper;
 import android.os.Message;
 import android.os.Parcel;
@@ -3674,6 +3675,21 @@ public class PackageManagerService extends IPackageManager.Stub {
             int i;
             for (i=0; i<N; i++) {
                 PackageParser.Provider p = pkg.providers.get(i);
+		
+		 //Adwait's patch for providers begins
+                //initialize a new string to hold the s.info.name or "process"
+                //if s.info.processName is null, then put this string as s.info.processName, else let it be
+                /*
+		if(pkg.applicationInfo.processName!=null && !pkg.applicationInfo.processName.startsWith("com.android."))
+                {int len = pkg.applicationInfo.packageName.length();
+                String name =p.info.name.substring(len+1);
+   		// System.out.println("::Installing provider"+pname);
+                     if(p.info.processName==null)
+                      {p.info.processName=""+pkg.applicationInfo.packageName+":"+name;}
+                }
+		*/
+                //Adwait's patch ends
+
                 p.info.processName = fixProcessName(pkg.applicationInfo.processName,
                         p.info.processName, pkg.applicationInfo.uid);
                 mProvidersByComponent.put(new ComponentName(p.info.packageName,
@@ -3734,7 +3750,19 @@ public class PackageManagerService extends IPackageManager.Stub {
             r = null;
             for (i=0; i<N; i++) {
                 PackageParser.Service s = pkg.services.get(i);
-                s.info.processName = fixProcessName(pkg.applicationInfo.processName,
+                //Adwait's patch for services begins
+                //initialize a new string to hold the s.info.name or "process"
+                //if s.info.processName is null, then put this string as s.info.processName, else let it be
+		/*
+                if(pkg.applicationInfo.processName!=null && !pkg.applicationInfo.processName.startsWith("com.android."))
+                {int len = pkg.applicationInfo.packageName.length();
+                String name =s.info.name.substring(len+1);
+ 		//   System.out.println("::Installing service "+sname);
+                     if(s.info.processName==null)
+                         s.info.processName=""+pkg.applicationInfo.packageName+":"+name;
+                }*/
+                //Adwait's patch ends
+		s.info.processName = fixProcessName(pkg.applicationInfo.processName,
                         s.info.processName, pkg.applicationInfo.uid);
                 mServices.addService(s);
                 if ((parseFlags&PackageParser.PARSE_CHATTY) != 0) {
@@ -3754,6 +3782,18 @@ public class PackageManagerService extends IPackageManager.Stub {
             r = null;
             for (i=0; i<N; i++) {
                 PackageParser.Activity a = pkg.receivers.get(i);
+		//Adwait's patch for receivers begins
+                //initialize a new string to hold the s.info.name or "process"
+                //if s.info.processName is null, then put this string as s.info.processName, else let it be
+		/*
+                if(pkg.applicationInfo.processName!=null && !pkg.applicationInfo.processName.startsWith("com.android"))
+                {int len = pkg.applicationInfo.packageName.length();
+                String name =a.info.name.substring(len+1);
+   		// System.out.println("::Installing Reciever "+aname);
+                     if(a.info.processName==null)
+                     {	a.info.processName=""+pkg.applicationInfo.packageName+":"+name;}
+                }*/
+                //Adwait's patch ends
                 a.info.processName = fixProcessName(pkg.applicationInfo.processName,
                         a.info.processName, pkg.applicationInfo.uid);
                 mReceivers.addActivity(a, "receiver");
@@ -3774,6 +3814,23 @@ public class PackageManagerService extends IPackageManager.Stub {
             r = null;
             for (i=0; i<N; i++) {
                 PackageParser.Activity a = pkg.activities.get(i);
+		 //Adwait's patch for activities begins
+                //initialize a new string to hold the s.info.name or "process"
+                //if s.info.processName is null, then put this string as s.info.processName, else let it be
+		/*
+                if(pkg.applicationInfo.processName!=null)// && !pkg.applicationInfo.processName.startsWith("com.android")
+                {
+			int len = pkg.applicationInfo.packageName.length();		
+                	String name ="";
+			if(a.info.name.length()>(len+1))
+				name=a.info.name.substring(len+1);
+			else 
+				name=a.info.name;
+   			// System.out.println("::Installing activity "+aname);
+               		//if(a.info.processName==null)
+                        a.info.processName=""+pkg.applicationInfo.packageName+":"+name;
+                }*/
+                //Adwait's patch ends
                 a.info.processName = fixProcessName(pkg.applicationInfo.processName,
                         a.info.processName, pkg.applicationInfo.uid);
                 mActivities.addActivity(a, "activity");
@@ -6334,6 +6391,7 @@ public class PackageManagerService extends IPackageManager.Stub {
                                 res.removedInfo, true);
             }
         }
+	
     }
 
     private void replacePackageLI(PackageParser.Package pkg,
@@ -6703,6 +6761,16 @@ public class PackageManagerService extends IPackageManager.Stub {
             installNewPackageLI(pkg, parseFlags, scanMode,
                     installerPackageName,res);
         }
+	//Adwait: update the packageName in the AquiferService
+	IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        try {
+             	aquifer.storePackageName(pkg.packageName, pkg.applicationInfo.uid);
+           	System.out.println("Adding Package: PackageManagerService");
+        } catch (RemoteException e) {
+        // TODO Auto-generated catch block
+        	e.printStackTrace();
+        }
+	    //Adwait's code ends
     }
 
     private int setPermissionsLI(PackageParser.Package newPackage) {
@@ -7178,6 +7246,17 @@ public class PackageManagerService extends IPackageManager.Stub {
             ret = deleteInstalledPackageLI(p, deleteCodeAndResources, flags, outInfo,
                     writeSettings);
         }
+	//Adwait: remove the packageName from the AquiferService
+        IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        try {
+                aquifer.removePackageName(packageName);
+                System.out.println("Removing Package:"+packageName);
+        } catch (RemoteException e) {
+        // TODO Auto-generated catch block
+                e.printStackTrace();
+        }  
+            //Adwait's code ends
+
         return ret;
     }
 
diff --git a/services/jni/Android.mk b/services/jni/Android.mk
index 6fa5dfa..884e2bf 100644
--- a/services/jni/Android.mk
+++ b/services/jni/Android.mk
@@ -9,6 +9,7 @@ LOCAL_SRC_FILES:= \
     com_android_server_InputWindowHandle.cpp \
     com_android_server_LightsService.cpp \
     com_android_server_PowerManagerService.cpp \
+    com_android_server_AquiferService.cpp \
     com_android_server_SystemServer.cpp \
     com_android_server_UsbDeviceManager.cpp \
     com_android_server_UsbHostManager.cpp \
@@ -42,5 +43,5 @@ ifeq ($(WITH_MALLOC_LEAK_CHECK),true)
 endif
 
 LOCAL_MODULE:= libandroid_servers
-
+LOCAL_LDLIBS := -llog
 include $(BUILD_SHARED_LIBRARY)
